Fix cpio call
[git.git] / git-merge.sh
index dd104db..74f0761 100755 (executable)
@@ -3,19 +3,15 @@
 # Copyright (c) 2005 Junio C Hamano
 #
 
-. git-sh-setup || die "Not a git archive"
+
+USAGE='[-n] [--no-commit] [-s <strategy>]... <merge-message> <head> <remote>+'
+. git-sh-setup
 
 LF='
 '
 
-usage () {
-    die "git-merge [-n] [--no-commit] [-s <strategy>]... <merge-message> <head> <remote>+"
-}
-
-# all_strategies='resolve recursive stupid octopus'
-
-all_strategies='recursive octopus resolve stupid'
-default_strategies='resolve octopus'
+all_strategies='recursive octopus resolve stupid ours'
+default_strategies='recursive'
 use_strategies=
 
 dropsave() {
@@ -90,11 +86,6 @@ do
        shift
 done
 
-case "$use_strategies" in
-'')
-       use_strategies=$default_strategies
-       ;;
-esac
 test "$#" -le 2 && usage ;# we need at least two heads.
 
 merge_msg="$1"
@@ -104,13 +95,23 @@ head=$(git-rev-parse --verify "$1"^0) || usage
 shift
 
 # All the rest are remote heads
+remoteheads=
 for remote
 do
-       git-rev-parse --verify "$remote"^0 >/dev/null ||
+       remotehead=$(git-rev-parse --verify "$remote"^0) ||
            die "$remote - not something we can merge"
+       remoteheads="${remoteheads}$remotehead "
 done
+set x $remoteheads ; shift
 
-common=$(git-show-branch --merge-base $head "$@")
+case "$#" in
+1)
+       common=$(git-merge-base --all $head "$@")
+       ;;
+*)
+       common=$(git-show-branch --merge-base $head "$@")
+       ;;
+esac
 echo "$head" >"$GIT_DIR/ORIG_HEAD"
 
 case "$#,$common,$no_commit" in
@@ -162,7 +163,7 @@ case "$#,$common,$no_commit" in
        up_to_date=t
        for remote
        do
-               common_one=$(git-merge-base $head $remote)
+               common_one=$(git-merge-base --all $head $remote)
                if test "$common_one" != "$remote"
                then
                        up_to_date=f
@@ -178,6 +179,17 @@ case "$#,$common,$no_commit" in
        ;;
 esac
 
+case "$use_strategies" in
+'')
+       case "$#" in
+       1)
+               use_strategies="$default_strategies" ;;
+       *)
+               use_strategies=octopus ;;
+       esac            
+       ;;
+esac
+
 # At this point, we need a real merge.  No matter what strategy
 # we use, it would operate on the index, possibly affecting the
 # working tree, and when resolved cleanly, have the desired tree
@@ -197,6 +209,7 @@ case "$use_strategies" in
 esac
 
 result_tree= best_cnt=-1 best_strategy= wt_strategy=
+merge_was_ok=
 for strategy in $use_strategies
 do
     test "$wt_strategy" = '' || {
@@ -216,6 +229,7 @@ do
     exit=$?
     if test "$no_commit" = t && test "$exit" = 0
     then
+        merge_was_ok=t
        exit=1 ;# pretend it left conflicts.
     fi
 
@@ -262,7 +276,8 @@ fi
 case "$best_strategy" in
 '')
        restorestate
-       die "No merge strategy handled the merge."
+       echo >&2 "No merge strategy handled the merge."
+       exit 2
        ;;
 "$wt_strategy")
        # We already have its result in the working tree.
@@ -278,6 +293,25 @@ for remote
 do
        echo $remote
 done >"$GIT_DIR/MERGE_HEAD"
-echo $merge_msg >"$GIT_DIR/MERGE_MSG"
+echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
 
-die "Automatic merge failed/prevented; fix up by hand"
+if test "$merge_was_ok" = t
+then
+       echo >&2 \
+       "Automatic merge went well; stopped before committing as requested"
+       exit 0
+else
+       {
+           echo '
+Conflicts:
+'
+               git ls-files --unmerged |
+               sed -e 's/^[^   ]*      /       /' |
+               uniq
+       } >>"$GIT_DIR/MERGE_MSG"
+       if test -d "$GIT_DIR/rr-cache"
+       then
+               git-rerere
+       fi
+       die "Automatic merge failed; fix up by hand"
+fi